import "./localStorage";

import { init, initializeLogin, finalizeLogin, credentialsProvider } from "@tidal-music/auth";

const clientId = "mhPVJJEBNRzVjr2p";

export default async () => {
    await init({
        clientId,
        credentialsStorageKey: "tidal-credentials",
        scopes: ["r_usr", "w_usr"],
    })

    const credentials = await credentialsProvider.getCredentials();

    if (typeof credentials.userId !== "string" || (credentials.expires || 0) < Date.now()) {

        const response = await initializeLogin({
            redirectUri: "https://desktop.tidal.com/login/auth"
        });

        console.log(`Please open ${response} to login.`)

        await finalizeLogin(new URL(prompt("Enter the URL you were redirected to: ") || "").search)
    }

    return {
        "Authorization": `Bearer ${(await credentialsProvider.getCredentials()).token || ""}`
    }
}